<script setup lang="ts">
import { ref, onMounted, nextTick } from 'vue'
import { useOrderStore } from '@/stores/Order'
import type { Order } from '@/types/Order'

const OrderStore = useOrderStore()
const loading = ref(false)
const form = ref(false)
const dialog = ref(false)
const checkStockdialog = ref(false)

const headers = [
  { title: 'Id', value: 'id', key: 'id' },
  { title: 'Total', value: 'total', key: 'total' },
  { title: 'Qty', value: 'qty', key: 'qty' },
  { title: 'UserId', value: 'userId', key: 'userId' },
  { title: 'Actions', key: 'actions', sortable: false }
]

onMounted(async () => {
  await OrderStore.getOrders()
})

function onSubmit() {}

async function editItem(item: Order) {
  if (!item.id) return
  await OrderStore.deleteOrder(item.id)
  dialog.value = true
}
async function confirmDeleteOrder(item: Order) {
  if (!item.id) return
  await OrderStore.deleteOrder(item.id)
  dialog.value = true
}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    OrderStore.clearForm()
  })
}

async function deleteItemConfirm() {
  await OrderStore.deleteOrder()
  closeDialog()
}

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await OrderStore.saveOrder()
  closeDialog()
}

function getColor(amount: number) {
  if (amount <= 5) return 'red'
  else if (amount >= 10) return 'green'
}
</script>

<template>
  <div>
    <v-data-table :headers="headers" :items="OrderStore.orders">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Orders</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog -->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" v-bind="props"> New Order </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Order Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="OrderStore.editedOrder.Date"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Id"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="OrderStore.editedOrder.Amount"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Total"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="OrderStore.editedOrder.Total_price"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Qty"
                          placeholder="Enter your password"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:[`item.image`]="{ item }">
        <v-img :src="'http://localhost:3000/images/orders/' + item.image" width="100"></v-img>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="OrderStore.getOrders"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>
